(*
  Copyright (C) BitBlaze, 2009-2010, and copyright (C) 2010 Ensighta
  Security Inc.  

#Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.

#THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*)

module V = Vine

class virtual decision_tree = object
  method virtual init : decision_tree
  method virtual reset : unit
  method virtual get_hist : bool list
  method virtual get_hist_str : string
  method virtual get_hist_str_queries : string
  method virtual get_hist_str_bracketed : string
  method virtual get_depth : int
  method virtual add_kid : bool -> unit
  method virtual start_new_query : unit
  method virtual start_new_query_binary : unit
  method virtual count_query : unit
  method virtual extend : bool -> unit
  method virtual set_iter_seed : int -> unit
  method virtual random_bit : bool
  method virtual record_unsat : bool -> unit

  method virtual try_extend : (bool -> V.exp) ->
    (bool -> V.exp -> bool) -> (bool -> unit) -> (unit -> bool) 
    -> (bool * V.exp)

  method virtual try_extend_memoryless : (bool -> V.exp) ->
    (bool -> V.exp -> bool) -> (bool -> unit) -> (unit -> bool) 
    -> (bool * V.exp)

  method virtual mark_all_seen : unit

  method virtual try_again_p : bool

  method virtual print_tree : out_channel -> unit
end
